Subject: Re: [PATCH-net] batman-adv: Fix "Arguments in wrong order" issue

From: Sven Eckelmann <[email-masked]>
Date: Fri, 15 Nov 2024 08:14:40 +0100

On Friday, 15 November 2024 05:56:37 CET Dheeraj Reddy Jonnalagadda wrote:
> This commit fixes an "Arguments in wrong order" issue detected by
> Coverity (CID 1376875).
> 
> Signed-off-by: Dheeraj Reddy Jonnalagadda <[email-masked]>
> ---
>  net/batman-adv/distributed-arp-table.c | 2 +-
>  1 file changed, 1 insertion(+), 1 deletion(-)
> 
> diff --git a/net/batman-adv/distributed-arp-table.c b/net/batman-adv/
distributed-arp-table.c
> index 801eff8a40e5..781a5118d441 100644
> --- a/net/batman-adv/distributed-arp-table.c
> +++ b/net/batman-adv/distributed-arp-table.c
> @@ -1195,7 +1195,7 @@ bool batadv_dat_snoop_outgoing_arp_request(struct 
batadv_priv *bat_priv,
>  			goto out;
>  		}
>  
> -		skb_new = batadv_dat_arp_create_reply(bat_priv, ip_dst, 
ip_src,
> +		skb_new = batadv_dat_arp_create_reply(bat_priv, ip_src, 
ip_dst,
dat_entry->mac_addr,
hw_src, vid);
>  		if (!skb_new)

Sorry, but this is wrong. We send an answer here ("ARP request 
replied locally") and of course we must then switch src and destination. 
Otherwise we would send the ARP response to the entity which didn't requested 
it.

This was already marked as false positive in Coverity a long time ago.

Kind regards,
	Sven